<template>
    <div class="row">
        <div class="col-xs-12">
            <h1 v-if="product.id">Edit {{product.name}}</h1>
            <h1 v-else>Add product</h1>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 col-md-6">
            <div class="form-group">
                <label>Status</label>
                <input type="checkbox" v-model="product.status" :checked="false"/>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 col-md-6" v-for="attribute in attributes">
            <div class="form-group">
                <label>{{attribute.name}}</label>
                <input type="text" v-model="product[attribute.code]" class="form-control"
                       v-if="attribute.type == 'text'"/>
                <textarea v-model="product[attribute.code]" class="form-control"
                          v-if="attribute.type == 'textarea'"></textarea>
                <input type="date" v-model="product[attribute.code]" class="form-control"
                       v-if="attribute.type == 'date'"/>
                <input type="number" v-model="product[attribute.code]" class="form-control"
                       v-if="attribute.type == 'number'"/>
                <select v-model="product[attribute.code]" class="form-control" v-if="attribute.type == 'select'">
                    <option v-for="option in attribute.options" v-bind:value="option._id">{{option.name}}</option>
                </select>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-xs-12">
            <label>Attributes</label>
            <div v-for="attribute in product.attributes">
                <label>{{ $key }}</label>
                <div>{{ attribute }}</div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 table-responsive">
            <label>Suppliers</label>
            <table class="table table-bordered">
                <thead>
                <tr>
                    <th v-for="header in tableHeaders">
                        {{header}}
                    </th>
                </tr>
                </thead>
                <tr v-for="supplier in product.suppliers">
                    <td>{{ supplier.name }}</td>
                    <td>{{ supplier.qty }}</td>
                    <td>{{ supplier.sku }}</td>
                    <td>{{ supplier.cost.price }} {{ supplier.cost.currency }}</td>
                </tr>
            </table>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 table-responsive">
            <label>Warehouses</label>
            <table class="table table-bordered">
                <thead>
                <tr>
                    <th v-for="header in tableHeaders">
                        {{header}}
                    </th>
                </tr>
                </thead>
                <tr v-for="warehouse in product.warehouses">
                    <td>{{ warehouse.name }}</td>
                    <td>{{ warehouse.qty }}</td>
                    <td>{{ warehouse.sku }}</td>
                    <td>{{ warehouse.cost.price }} {{ warehouse.cost.currency }}</td>
                </tr>
            </table>
        </div>
    </div>

    <div class="row">
        <div class="col-xs-12">
            <span class="btn btn-default custom-attrs-form__save" @click="saveProduct()">Save</span>
            <span class="btn btn-danger repeater__button--delete" @click="deleteProduct()">Delete</span>
        </div>
    </div>
</template>

<script>
    export default {
        data: function () {
            return {
                product: {},
                attributes: [{}],
                tableHeaders: ["Name", "Qty", "SKU", "Cost"]
            }
        },
        route: {
            data(transition) {
                this.$http.get('/api/v1/product-attributes/aggregated').then(function (res) {
                    this.attributes = res.data;
//                    return {
//                        attributes: res.data
//                    }
                });

                var id = this.$route.params.id;
                if (id != undefined) {
                    return this.$http.get('/api/v1/products/product/' + id).then(function (res) {
                        return {
                            product: res.data[0].document
                        }
                    })
                }
            }
        },
        methods: {
            deleteProduct: function () {
                if (this.product.id) {
                    this.$http.delete('/api/v1/products/delete/' + this.product.id).then(function (res) {
                        console.log(res.data);
                    });
                }
            },
            saveProduct: function () {
                if (this.product.id) {
                    this.$http.put('/api/v1/products/update/' + this.product.id, this.product).then(function (res) {
                        console.log(res.data);
                    })
                } else {
                    this.$http.post('/api/v1/products/create', this.product).then(function (res) {
                        console.log(res.data);
                    })
                }
            }
        },
    }
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>

</style>
